diff -rNci gcc-2.7.2/sched.c gcc-2.7.2p/sched.c
*** gcc-2.7.2/sched.c	Thu Jun 15 12:06:39 1995
--- gcc-2.7.2p/sched.c	Tue Jan 30 21:06:34 1996
***************
*** 4965,4968 ****
--- 5646,5931 ----
  	  }
      }
  }
+ /* intel1
+    return 1 if insn_b is part of the SCHED_GROUP of insn_a 
+ */
+ static int
+ is_part_of_group (insn_a, insn_b)
+      rtx insn_a;
+      rtx insn_b;
+ {
+   rtx pn;
+ 
+   pn = PREV_INSN(insn_a);
+   while(pn)
+     {
+       if(GET_CODE(pn)==INSN || GET_CODE(pn)==CALL_INSN ||
+          GET_CODE(pn)==JUMP_INSN)
+         {
+           if(pn==insn_b)
+             {
+               return(1);
+             }
+           if(!SCHED_GROUP_P(pn))
+             {
+               return(0);
+             }
+         }
+       pn = PREV_INSN(pn);
+     }
+   return(0);
+ }
+ 
+ /* intel1 return 1 if there are insts in block b before insn */
+ static int prev_insts_in_block(b, insn)
+ int b;
+ rtx insn;
+ {
+   insn = PREV_INSN(insn);
+   while(insn && insn!=basic_block_head[b])
+     {
+       if(GET_RTX_CLASS (GET_CODE (insn)) == 'i')
+         {
+           return(1);
+         }
+       insn = PREV_INSN(insn);
+     }
+   if(insn && 
+      insn==basic_block_head[b] && GET_RTX_CLASS (GET_CODE (insn)) == 'i')
+     {
+       return(1);
+     }
+   return(0);
+ }
+ 
+ #ifdef AGI
+ /* intel1
+   If insn updates a register by a constant and NEXT_INSN (insn) uses
+   that register as a base or index and this is the only dependence
+   between the two insns - then try to swap these two insns by replacing
+   register with (register + constant) in NEXT_INSN (insn).  
+ */
+ int try_eliminate_agi (insn, file)
+   rtx insn;
+   FILE * file;
+ {
+   rtx next;
+   int success;
+   
+   next = NEXT_INSN (insn);
+   if (!try_swap (insn))
+     {
+       return (0);
+     }
+   /* Now swap insn with next.  */
+   PREV_INSN (NEXT_INSN (next)) = insn;
+   NEXT_INSN (insn) = NEXT_INSN (next);
+   NEXT_INSN (next) = insn;
+   PREV_INSN (insn) = next;
+   success = 1;
+   if (file)
+     {
+       fprintf (file, ";; swapped %d with %d to eliminate agi, %d is last scheduled\n",
+       INSN_UID (insn), INSN_UID (next), INSN_UID (next));
+     }
+   while (success)
+     {  /* Keep trying to swap insn downwards */
+       success = try_swap (insn);
+       if (success)
+         {
+           next = NEXT_INSN (insn);
+           if (file)
+             {
+               fprintf (file, ";;   (swapped %d with %d to eliminate agi)\n",
+               INSN_UID (insn), INSN_UID (next));
+             }
+           NEXT_INSN (PREV_INSN (insn)) = next;
+           PREV_INSN (next) = PREV_INSN (insn);
+           PREV_INSN (NEXT_INSN (next)) = insn;
+           NEXT_INSN (insn) = NEXT_INSN (next);
+           NEXT_INSN (next) = insn;
+           PREV_INSN (insn) = next;
+         }
+     }
+   return (1);
+ }
+ 
+ int try_swap (insn)
+   rtx insn;
+ {
+   rtx next, tmp, src, dest, next_src, next_dest, reg_to_update,
+       copy_dest, copy_src;
+   int offst_update, updates_by_const, regno_updated, length, i,
+       insn_code_number, save_code;
+   char * fmt, * storage;
+   next = NEXT_INSN (insn);
+   if (GET_CODE (insn) != INSN || next == NULL || GET_CODE (next) != INSN
+       || GET_CODE (PATTERN (insn)) != SET || GET_CODE (PATTERN (next)) != SET)
+     {
+       return (0);
+     }
+   src = SET_SRC (PATTERN (insn));
+   dest = SET_DEST (PATTERN (insn));
+   next_src = SET_SRC (PATTERN (next));
+   next_dest = SET_DEST (PATTERN (next));
+   if (next_dest == cc0_rtx)
+     {
+       return (0);
+     }
+   if (rtx_equal_p (dest, next_dest))
+     {
+       return (0);
+     }
+   if (GET_CODE (next_dest) == REG)
+     {
+       if (reg_overlap_mentioned_p (next_dest, PATTERN (insn)))
+         {
+           return (0);
+         }
+     }
+   /* See if insn updates some register by a constant ammount */
+   updates_by_const = 0;
+   if (GET_CODE (dest) == REG)
+     {
+       if ((GET_CODE (src) == PLUS || GET_CODE (src) == MINUS)
+           && rtx_equal_p (XEXP (src, 0), dest) 
+           && GET_CODE (XEXP (src, 1)) == CONST_INT)
+         {
+           updates_by_const = 1;
+           offst_update 
+             = XINT (XEXP (src, 1), 0) * (GET_CODE (src) == PLUS ? 1 : -1);
+           regno_updated = REGNO (dest);
+           reg_to_update = dest;
+         }
+     }
+   if (GET_CODE (dest) == MEM && push_operand (dest, GET_MODE (dest))
+       && (GET_CODE (src) == REG
+           || (GET_CODE (src) == MEM && !side_effects_p (XEXP (src, 0)))))
+     {
+       updates_by_const = 1;
+       offst_update = GET_MODE_SIZE (GET_MODE (dest));
+       if (GET_CODE (XEXP (dest, 0)) == PRE_DEC ||
+           GET_CODE (XEXP (dest, 0)) == POST_DEC)
+         {
+           offst_update *= -1;
+         }
+       regno_updated = STACK_POINTER_REGNUM;
+       reg_to_update = stack_pointer_rtx;
+     }
+   if (!updates_by_const)
+     {
+       return (0);
+     }
+   if (!reg_overlap_mentioned_p (reg_to_update, PATTERN (next)))
+     {
+       return (0);
+     }
+   if (GET_CODE (dest) == MEM)
+     {
+       if (GET_CODE (next_src) == MEM
+            && true_dependence (dest, next_src))
+         {
+           return (0);
+         }
+       else if (GET_CODE (next_src) != REG)
+         {
+           fmt = GET_RTX_FORMAT (GET_CODE (next_src));
+           length = GET_RTX_LENGTH (GET_CODE (next_src));
+           for (i=0; i<length; i++)
+             {
+               if (fmt[i] == 'e' && GET_CODE (XEXP (next_src, i)) == MEM)
+                 {
+                   if (true_dependence (dest, XEXP (next_src, i)))
+                     {
+                       return (0);
+                     }
+                 }
+             }
+         }
+       if (GET_CODE (next_dest) == MEM
+            && true_dependence (dest, next_dest))
+         {
+           return (0);
+         }
+     }
+   if (GET_CODE (src) == MEM)
+     {
+       if (GET_CODE (next_dest) == MEM
+            && true_dependence (src, next_dest))
+         {
+           return (0);
+         }
+     }
+   /* First check that regno_updated is not used in next with any
+      other mode */
+   init_undo_buf ();
+   subst_in_insn (next, PATTERN (next), reg_to_update, const0_rtx, 0, 0);
+   if (reg_overlap_mentioned_p (reg_to_update, PATTERN (next)))
+     {
+       loop_undo_all ();
+       return (0);
+     }
+   loop_undo_all ();
+   /* Now substitute reg_to_update with  reg_to_update + offst_update.  */
+   storage = (char *) oballoc (0);
+   /* Since may be sharing of rtl */
+   copy_dest = copy_rtx (next_dest);
+   copy_src = copy_rtx (next_src);
+   SET_SRC (PATTERN (next)) = copy_src;
+   SET_DEST (PATTERN (next)) = copy_dest;
+   init_undo_buf ();
+   subst_in_insn (next, PATTERN (next), reg_to_update,
+                  gen_rtx (PLUS , GET_MODE (reg_to_update), reg_to_update,
+                           gen_rtx (CONST_INT, 0, offst_update)), 0, 0);
+ #ifdef REWRITE_ADDRESS
+   if (GET_CODE (copy_dest) == MEM)
+     {
+       REWRITE_ADDRESS (copy_dest);
+     }
+   if (GET_CODE (copy_src) == MEM)
+     {
+       REWRITE_ADDRESS (copy_src);
+     }
+   else
+     {
+       fmt = GET_RTX_FORMAT (GET_CODE (copy_src));
+       length = GET_RTX_LENGTH (GET_CODE (copy_src));
+       for (i=0; i<length; i++)
+         {
+           if (fmt[i] == 'e' && GET_CODE (XEXP (copy_src, i)) == MEM)
+             {
+               REWRITE_ADDRESS (XEXP (copy_src, i));
+             }
+         }
+     }
+ #endif
+   if ((insn_code_number = recog (PATTERN (next), next, 0)) < 0)
+     {
+       loop_undo_all ();
+       SET_DEST (PATTERN (next)) = next_dest;
+       SET_SRC (PATTERN (next)) = next_src;
+       obfree (storage);
+       return (0);
+     }
+   else
+     {
+ #ifdef REGISTER_CONSTRAINTS
+       save_code = INSN_CODE (next);
+       INSN_CODE (next) = insn_code_number;
+       insn_extract (next);
+       if (!constrain_operands (insn_code_number, 1))
+ 	{
+ 	  loop_undo_all ();
+           SET_DEST (PATTERN (next)) = next_dest;
+           SET_SRC (PATTERN (next)) = next_src;
+ 	  INSN_CODE (next) = save_code;
+           obfree (storage);
+ 	  return (0);
+ 	}
+ #endif
+     }
+   return (1);
+ }
+ #endif
+ 
  #endif /* INSN_SCHEDULING */
diff -rNci gcc-2.7.2/stmt.c gcc-2.7.2p/stmt.c
*** gcc-2.7.2/stmt.c	Tue Sep 12 23:01:54 1995
--- gcc-2.7.2p/stmt.c	Thu Jun 15 12:08:17 1995
***************
*** 467,472 ****
--- 467,482 ----
  static void emit_jump_if_reachable	PROTO((rtx));
  static void emit_case_nodes		PROTO((rtx, case_node_ptr, rtx, tree));
  
+ int bc_expand_exit_loop_if_false ();
+ void bc_expand_start_cond ();
+ void bc_expand_end_cond ();
+ void bc_expand_start_else ();
+ void bc_expand_end_bindings ();
+ void bc_expand_start_case ();
+ void bc_check_for_full_enumeration_handling ();
+ void bc_expand_end_case ();
+ void bc_expand_decl ();
+ 
  extern rtx bc_allocate_local ();
  extern rtx bc_allocate_variable_array ();
  
***************
*** 553,560 ****
        last_insn = get_last_insn ();
        if (!optimize
  	  && (GET_CODE (last_insn) == CODE_LABEL
! 	      || (GET_CODE (last_insn) == NOTE
! 		  && prev_real_insn (last_insn) == 0)))
  	emit_insn (gen_nop ());
      }
  }
--- 563,569 ----
        last_insn = get_last_insn ();
        if (!optimize
  	  && (GET_CODE (last_insn) == CODE_LABEL
! 	      || prev_real_insn (last_insn) == 0))
  	emit_insn (gen_nop ());
      }
  }
***************
*** 1246,1252 ****
  	      f->before_jump
  		= emit_insns_after (cleanup_insns, f->before_jump);
  
! 	      f->cleanup_list_list = TREE_CHAIN (lists);
  	    }
  
  	if (stack_level)
--- 1255,1261 ----
  	      f->before_jump
  		= emit_insns_after (cleanup_insns, f->before_jump);
  
! 	      TREE_VALUE (lists) = 0;
  	    }
  
  	if (stack_level)
***************
*** 1508,1514 ****
    for (tail = inputs; tail; tail = TREE_CHAIN (tail))
      {
        int j;
-       int allows_reg = 0;
  
        /* If there's an erroneous arg, emit no insn,
  	 because the ASM_INPUT would get VOIDmode
--- 1517,1522 ----
***************
*** 1524,1588 ****
  
        /* Make sure constraint has neither `=' nor `+'.  */
  
!       for (j = 0; j < TREE_STRING_LENGTH (TREE_PURPOSE (tail)) - 1; j++)
! 	switch (TREE_STRING_POINTER (TREE_PURPOSE (tail))[j])
  	  {
- 	  case '+':   case '=':
  	    error ("input operand constraint contains `%c'",
  		   TREE_STRING_POINTER (TREE_PURPOSE (tail))[j]);
  	    return;
- 
- 	  case '?':  case '!':  case '*':  case '%':  case '&':
- 	  case 'V':  case 'm':  case 'o':  case '<':  case '>':
- 	  case 'E':  case 'F':  case 'G':  case 'H':  case 'X':
- 	  case 's':  case 'i':  case 'n':
- 	  case 'I':  case 'J':  case 'K':  case 'L':  case 'M':
- 	  case 'N':  case 'O':  case 'P':  case ',':
- #ifdef EXTRA_CONSTRAINT
- 	  case 'Q':  case 'R':  case 'S':  case 'T':  case 'U':
- #endif
- 	    break;
- 
- 	  case '0':  case '1':  case '2':  case '3':  case '4':
- 	  case 'p':  case 'g':  case 'r':
- 	  default:
- 	    allows_reg = 1;
- 	    break;
  	  }
  
-       if (! allows_reg)
- 	mark_addressable (TREE_VALUE (tail));
- 
        XVECEXP (body, 3, i)      /* argvec */
  	= expand_expr (TREE_VALUE (tail), NULL_RTX, VOIDmode, 0);
        if (CONSTANT_P (XVECEXP (body, 3, i))
  	  && ! general_operand (XVECEXP (body, 3, i),
  				TYPE_MODE (TREE_TYPE (TREE_VALUE (tail)))))
! 	{
! 	  if (allows_reg)
! 	    XVECEXP (body, 3, i)
! 	      = force_reg (TYPE_MODE (TREE_TYPE (TREE_VALUE (tail))),
! 			   XVECEXP (body, 3, i));
! 	  else
! 	    XVECEXP (body, 3, i)
! 	      = force_const_mem (TYPE_MODE (TREE_TYPE (TREE_VALUE (tail))),
! 				 XVECEXP (body, 3, i));
! 	}
! 
!       if (! allows_reg
! 	  && (GET_CODE (XVECEXP (body, 3, i)) == REG
! 	      || GET_CODE (XVECEXP (body, 3, i)) == SUBREG
! 	      || GET_CODE (XVECEXP (body, 3, i)) == CONCAT))
! 	{
! 	  tree type = TREE_TYPE (TREE_VALUE (tail));
! 	  rtx memloc = assign_stack_temp (TYPE_MODE (type),
! 					  int_size_in_bytes (type), 1);
! 
! 	  MEM_IN_STRUCT_P (memloc) = AGGREGATE_TYPE_P (type);
! 	  emit_move_insn (memloc, XVECEXP (body, 3, i));
! 	  XVECEXP (body, 3, i) = memloc;
! 	}
! 	  
        XVECEXP (body, 4, i)      /* constraints */
  	= gen_rtx (ASM_INPUT, TYPE_MODE (TREE_TYPE (TREE_VALUE (tail))),
  		   TREE_STRING_POINTER (TREE_PURPOSE (tail)));
--- 1532,1554 ----
  
        /* Make sure constraint has neither `=' nor `+'.  */
  
!       for (j = 0; j < TREE_STRING_LENGTH (TREE_PURPOSE (tail)); j++)
! 	if (TREE_STRING_POINTER (TREE_PURPOSE (tail))[j] == '='
! 	    || TREE_STRING_POINTER (TREE_PURPOSE (tail))[j] == '+')
  	  {
  	    error ("input operand constraint contains `%c'",
  		   TREE_STRING_POINTER (TREE_PURPOSE (tail))[j]);
  	    return;
  	  }
  
        XVECEXP (body, 3, i)      /* argvec */
  	= expand_expr (TREE_VALUE (tail), NULL_RTX, VOIDmode, 0);
        if (CONSTANT_P (XVECEXP (body, 3, i))
  	  && ! general_operand (XVECEXP (body, 3, i),
  				TYPE_MODE (TREE_TYPE (TREE_VALUE (tail)))))
! 	XVECEXP (body, 3, i)
! 	  = force_reg (TYPE_MODE (TREE_TYPE (TREE_VALUE (tail))),
! 		       XVECEXP (body, 3, i));
        XVECEXP (body, 4, i)      /* constraints */
  	= gen_rtx (ASM_INPUT, TYPE_MODE (TREE_TYPE (TREE_VALUE (tail))),
  		   TREE_STRING_POINTER (TREE_PURPOSE (tail)));
***************
*** 1885,1891 ****
    momentary = suspend_momentary ();
    t = make_node (RTL_EXPR);
    resume_momentary (momentary);
-   do_pending_stack_adjust ();
    start_sequence_for_rtl_expr (t);
    NO_DEFER_POP;
    expr_stmts_for_value++;
--- 1851,1856 ----
***************
*** 2757,2816 ****
        && TYPE_MODE (TREE_TYPE (retval_rhs)) == BLKmode
        && GET_CODE (DECL_RTL (DECL_RESULT (current_function_decl))) == REG)
      {
!       int i, bitpos, xbitpos;
        int big_endian_correction = 0;
        int bytes = int_size_in_bytes (TREE_TYPE (retval_rhs));
        int n_regs = (bytes + UNITS_PER_WORD - 1) / UNITS_PER_WORD;
-       int bitsize = MIN (TYPE_ALIGN (TREE_TYPE (retval_rhs)),BITS_PER_WORD);
        rtx *result_pseudos = (rtx *) alloca (sizeof (rtx) * n_regs);
!       rtx result_reg, src, dst;
        rtx result_val = expand_expr (retval_rhs, NULL_RTX, VOIDmode, 0);
        enum machine_mode tmpmode, result_reg_mode;
  
!       /* Structures whose size is not a multiple of a word are aligned
! 	 to the least significant byte (to the right).  On a BYTES_BIG_ENDIAN
! 	 machine, this means we must skip the empty high order bytes when
! 	 calculating the bit offset.  */
!       if (BYTES_BIG_ENDIAN && bytes % UNITS_PER_WORD)
! 	big_endian_correction = (BITS_PER_WORD - ((bytes % UNITS_PER_WORD)
! 						  * BITS_PER_UNIT));
! 
!       /* Copy the structure BITSIZE bits at a time.  */ 
!       for (bitpos = 0, xbitpos = big_endian_correction;
! 	   bitpos < bytes * BITS_PER_UNIT;
! 	   bitpos += bitsize, xbitpos += bitsize)
! 	{
! 	  /* We need a new destination pseudo each time xbitpos is
! 	     on a word boundary and when xbitpos == big_endian_correction
! 	     (the first time through).  */
! 	  if (xbitpos % BITS_PER_WORD == 0
! 	      || xbitpos == big_endian_correction)
  	    {
! 	      /* Generate an appropriate register.  */
! 	      dst = gen_reg_rtx (word_mode);
! 	      result_pseudos[xbitpos / BITS_PER_WORD] = dst;
  
! 	      /* Clobber the destination before we move anything into it.  */
! 	      emit_insn (gen_rtx (CLOBBER, VOIDmode, dst));
  	    }
- 
- 	  /* We need a new source operand each time bitpos is on a word
- 	     boundary.  */
- 	  if (bitpos % BITS_PER_WORD == 0)
- 	    src = operand_subword_force (result_val,
- 					 bitpos / BITS_PER_WORD,
- 					 BLKmode);
- 
- 	  /* Use bitpos for the source extraction (left justified) and
- 	     xbitpos for the destination store (right justified).  */
- 	  store_bit_field (dst, bitsize, xbitpos % BITS_PER_WORD, word_mode,
- 			   extract_bit_field (src, bitsize,
- 					      bitpos % BITS_PER_WORD, 1,
- 					      NULL_RTX, word_mode,
- 					      word_mode,
- 					      bitsize / BITS_PER_UNIT,
- 					      BITS_PER_WORD),
- 			   bitsize / BITS_PER_UNIT, BITS_PER_WORD);
  	}
  
        /* Find the smallest integer mode large enough to hold the
--- 2722,2772 ----
        && TYPE_MODE (TREE_TYPE (retval_rhs)) == BLKmode
        && GET_CODE (DECL_RTL (DECL_RESULT (current_function_decl))) == REG)
      {
!       int i;
        int big_endian_correction = 0;
        int bytes = int_size_in_bytes (TREE_TYPE (retval_rhs));
        int n_regs = (bytes + UNITS_PER_WORD - 1) / UNITS_PER_WORD;
        rtx *result_pseudos = (rtx *) alloca (sizeof (rtx) * n_regs);
!       rtx result_reg;
        rtx result_val = expand_expr (retval_rhs, NULL_RTX, VOIDmode, 0);
        enum machine_mode tmpmode, result_reg_mode;
  
!       /* Structures smaller than a word are aligned to the least significant
! 	 byte (to the right).  On a BYTES_BIG_ENDIAN machine, this means we
! 	 must skip the empty high order bytes when calculating the bit
! 	 offset.  */
!       if (BYTES_BIG_ENDIAN && bytes < UNITS_PER_WORD)
! 	big_endian_correction = (BITS_PER_WORD - (bytes * BITS_PER_UNIT));
! 
!       for (i = 0; i < n_regs; i++)
! 	{
! 	  rtx reg = gen_reg_rtx (word_mode);
! 	  rtx word = operand_subword_force (result_val, i, BLKmode);
! 	  int bitsize = MIN (TYPE_ALIGN (TREE_TYPE (retval_rhs)),BITS_PER_WORD);
! 	  int bitpos;
! 
! 	  result_pseudos[i] = reg;
! 
! 	  /* Clobber REG and move each partword into it.  Ensure we don't
! 	     go past the end of the structure.  Note that the loop below
! 	     works because we've already verified that padding and
! 	     endianness are compatible.  */
! 	  emit_insn (gen_rtx (CLOBBER, VOIDmode, reg));
! 
! 	  for (bitpos = 0;
! 	       bitpos < BITS_PER_WORD && bytes > 0;
! 	       bitpos += bitsize, bytes -= bitsize / BITS_PER_UNIT)
  	    {
! 	      int xbitpos = bitpos + big_endian_correction;
  
! 	      store_bit_field (reg, bitsize, xbitpos, word_mode,
! 			       extract_bit_field (word, bitsize, bitpos, 1,
! 						  NULL_RTX, word_mode,
! 						  word_mode,
! 						  bitsize / BITS_PER_UNIT,
! 						  BITS_PER_WORD),
! 			       bitsize / BITS_PER_UNIT, BITS_PER_WORD);
  	    }
  	}
  
        /* Find the smallest integer mode large enough to hold the
***************
*** 3310,3316 ****
  }
  
  /* Generate RTL for the automatic variable declaration DECL.
!    (Other kinds of declarations are simply ignored if seen here.)  */
  
  void
  expand_decl (decl)
--- 3266,3287 ----
  }
  
  /* Generate RTL for the automatic variable declaration DECL.
!    (Other kinds of declarations are simply ignored if seen here.)
!    CLEANUP is an expression to be executed at exit from this binding contour;
!    for example, in C++, it might call the destructor for this variable.
! 
!    If CLEANUP contains any SAVE_EXPRs, then you must preevaluate them
!    either before or after calling `expand_decl' but before compiling
!    any subsequent expressions.  This is because CLEANUP may be expanded
!    more than once, on different branches of execution.
!    For the same reason, CLEANUP may not contain a CALL_EXPR
!    except as its topmost node--else `preexpand_calls' would get confused.
! 
!    If CLEANUP is nonzero and DECL is zero, we record a cleanup
!    that is not associated with any particular variable.
! 
!    There is no special support here for C++ constructors.
!    They should be handled by the proper code in DECL_INITIAL.  */
  
  void
  expand_decl (decl)
***************
*** 3683,3689 ****
     for example, in C++, it might call the destructor for this variable.
  
     If CLEANUP contains any SAVE_EXPRs, then you must preevaluate them
!    either before or after calling `expand_decl_cleanup' but before compiling
     any subsequent expressions.  This is because CLEANUP may be expanded
     more than once, on different branches of execution.
     For the same reason, CLEANUP may not contain a CALL_EXPR
--- 3654,3660 ----
     for example, in C++, it might call the destructor for this variable.
  
     If CLEANUP contains any SAVE_EXPRs, then you must preevaluate them
!    either before or after calling `expand_decl' but before compiling
     any subsequent expressions.  This is because CLEANUP may be expanded
     more than once, on different branches of execution.
     For the same reason, CLEANUP may not contain a CALL_EXPR
***************
*** 3726,3733 ****
    struct nesting *thisblock = block_stack;
    rtx x;
  
!   expand_decl (decl);
!   expand_decl_cleanup (decl, cleanup);
    x = DECL_RTL (decl);
  
    while (decl_elts)
--- 3697,3703 ----
    struct nesting *thisblock = block_stack;
    rtx x;
  
!   expand_decl (decl, cleanup);
    x = DECL_RTL (decl);
  
    while (decl_elts)
diff -rNci gcc-2.7.2/stor-layout.c gcc-2.7.2p/stor-layout.c
*** gcc-2.7.2/stor-layout.c	Tue Oct  3 23:15:07 1995
--- gcc-2.7.2p/stor-layout.c	Thu Jun 15 12:08:47 1995
***************
*** 81,96 ****
    return chain;
  }
  
- void
- put_pending_sizes (chain)
-      tree chain;
- {
-   if (pending_sizes)
-     abort ();
- 
-   pending_sizes = chain;
- }
- 
  /* Given a size SIZE that may not be a constant, return a SAVE_EXPR
     to serve as the actual size-expression for a type or decl.  */
  
--- 81,86 ----
***************
*** 747,774 ****
  	if (index && TYPE_MAX_VALUE (index) && TYPE_MIN_VALUE (index)
  	    && TYPE_SIZE (element))
  	  {
! 	    tree ub = TYPE_MAX_VALUE (index);
! 	    tree lb = TYPE_MIN_VALUE (index);
! 	    tree length;
! 
! 	    /* If UB is max (lb - 1, x), remove the MAX_EXPR since the
! 	       test for negative below covers it.  */
! 	    if (TREE_CODE (ub) == MAX_EXPR
! 		&& TREE_CODE (TREE_OPERAND (ub, 0)) == MINUS_EXPR
! 		&& integer_onep (TREE_OPERAND (TREE_OPERAND (ub, 0), 1))
! 		&& operand_equal_p (TREE_OPERAND (TREE_OPERAND (ub, 0), 0),
! 				    lb, 0))
! 	      ub = TREE_OPERAND (ub, 1);
! 	    else if (TREE_CODE (ub) == MAX_EXPR
! 		     && TREE_CODE (TREE_OPERAND (ub, 1)) == MINUS_EXPR
! 		     && integer_onep (TREE_OPERAND (TREE_OPERAND (ub, 1), 1))
! 		     && operand_equal_p (TREE_OPERAND (TREE_OPERAND (ub, 1),
! 						       0),
! 					 lb, 0))
! 	      ub = TREE_OPERAND (ub, 0);
! 
! 	    length = size_binop (PLUS_EXPR, size_one_node,
! 				 size_binop (MINUS_EXPR, ub, lb));
  
  	    /* If neither bound is a constant and sizetype is signed, make
  	       sure the size is never negative.  We should really do this
--- 737,746 ----
  	if (index && TYPE_MAX_VALUE (index) && TYPE_MIN_VALUE (index)
  	    && TYPE_SIZE (element))
  	  {
! 	    tree length
! 	      = size_binop (PLUS_EXPR, size_one_node,
! 			    size_binop (MINUS_EXPR, TYPE_MAX_VALUE (index),
! 					TYPE_MIN_VALUE (index)));
  
  	    /* If neither bound is a constant and sizetype is signed, make
  	       sure the size is never negative.  We should really do this
diff -rNci gcc-2.7.2/stupid.c gcc-2.7.2p/stupid.c
*** gcc-2.7.2/stupid.c	Sun Oct 29 12:45:22 1995
--- gcc-2.7.2p/stupid.c	Thu Jun 15 12:09:19 1995
***************
*** 423,441 ****
  
    if (code == SET || code == CLOBBER)
      {
!       if (SET_DEST (x) != 0
! 	  && (GET_CODE (SET_DEST (x)) == REG
! 	      || (GET_CODE (SET_DEST (x)) == SUBREG
! 		  && GET_CODE (SUBREG_REG (SET_DEST (x))) == REG
! 		  && (REGNO (SUBREG_REG (SET_DEST (x)))
! 		      >= FIRST_PSEUDO_REGISTER))))
  	{
  	  /* Register is being assigned.  */
! 	  /* If setting a SUBREG, we treat the entire reg as being set.  */
! 	  if (GET_CODE (SET_DEST (x)) == SUBREG)
! 	    regno = REGNO (SUBREG_REG (SET_DEST (x)));
! 	  else
! 	    regno = REGNO (SET_DEST (x));
  
  	  /* For hard regs, update the where-live info.  */
  	  if (regno < FIRST_PSEUDO_REGISTER)
--- 423,432 ----
  
    if (code == SET || code == CLOBBER)
      {
!       if (SET_DEST (x) != 0 && GET_CODE (SET_DEST (x)) == REG)
  	{
  	  /* Register is being assigned.  */
! 	  regno = REGNO (SET_DEST (x));
  
  	  /* For hard regs, update the where-live info.  */
  	  if (regno < FIRST_PSEUDO_REGISTER)
